"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _got = _interopRequireDefault(require("got"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const API_ACTION = {
  INVALIDATE_SSR_CACHE_BY_PATH: "invalidateSsrCacheByPath",
  INVALIDATE_SSR_CACHE_BY_TAGS: "invalidateSsrCacheByTags"
};

const ssrApiCall = async ({
  url,
  action,
  actionPayload,
  async
}) => {
  const args = {
    method: "POST",
    body: JSON.stringify({
      ssr: [action, actionPayload]
    })
  };

  if (async === false) {
    return await (0, _got.default)(url, args);
  }

  try {
    await (0, _got.default)(url, _objectSpread({}, args, {
      timeout: 200,
      retry: 0
    }));
  } catch (_unused) {// Do nothing.
  }
};

class Client {
  constructor(url) {
    (0, _defineProperty2.default)(this, "url", void 0);
    this.url = url;
  }

  async invalidateSsrCacheByPath({
    path = null,
    refresh = false,
    expired = false,
    async = true
  }) {
    await ssrApiCall({
      url: this.url,
      action: API_ACTION.INVALIDATE_SSR_CACHE_BY_PATH,
      actionPayload: {
        path,
        refresh,
        expired
      },
      async
    });
  }

  async invalidateSsrCacheByTags({
    tags = null,
    async = true
  }) {
    await ssrApiCall({
      url: this.url,
      action: API_ACTION.INVALIDATE_SSR_CACHE_BY_TAGS,
      actionPayload: {
        tags
      },
      async
    });
  }

}

exports.default = Client;
//# sourceMappingURL=Client.js.map