"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ssrCacheApi = _interopRequireDefault(require("./ssrCacheApi"));

var _ssrServe = _interopRequireDefault(require("./ssrServe"));

var _models = _interopRequireDefault(require("./models"));

var _fields = require("@webiny/commodo/fields");

const OptionsModel = (0, _fields.withFields)({
  ssrFunction: (0, _fields.string)({
    value: process.env.SSR_FUNCTION
  }),
  cache: (0, _fields.fields)({
    value: {},
    instanceOf: (0, _fields.withFields)({
      enabled: (0, _fields.boolean)({
        value: false
      }),
      ttl: (0, _fields.number)({
        value: 80
      }),
      staleTtl: (0, _fields.number)({
        value: 20
      })
    })()
  })
})();

var _default = rawOptions => {
  const options = new OptionsModel().populate(rawOptions);
  const plugins = [(0, _models.default)(options), (0, _ssrServe.default)(options)];

  if (options.cache.enabled) {
    plugins.push((0, _ssrCacheApi.default)());
  }

  return plugins;
};

exports.default = _default;
//# sourceMappingURL=index.js.map