"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash.flow"));

var _fieldsStorage = require("@webiny/commodo/fields-storage");

var _ssrCache = _interopRequireDefault(require("./ssrCache.model"));

var _commodoFieldsStorageDbProxy = require("@webiny/commodo-fields-storage-db-proxy");

var _default = options => ({
  type: "context",
  name: "context-models",

  apply({
    context
  }) {
    const createBase = () => (0, _lodash.default)((0, _commodoFieldsStorageDbProxy.withId)(), (0, _fieldsStorage.withStorage)({
      driver: new _commodoFieldsStorageDbProxy.DbProxyDriver({
        dbProxyFunctionName: process.env.DB_PROXY_FUNCTION
      })
    }))();

    const SsrCache = (0, _ssrCache.default)({
      createBase,
      options
    });
    context.models = {
      SsrCache
    };
  }

});

exports.default = _default;
//# sourceMappingURL=index.js.map