"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _querystringify = _interopRequireDefault(require("querystringify"));

var _lambda = _interopRequireDefault(require("aws-sdk/clients/lambda"));

var _httpHandler = require("@webiny/http-handler");

var _mimeTypes = _interopRequireDefault(require("mime-types"));

var _functions = require("./functions");

var _zlib = _interopRequireDefault(require("zlib"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _default = options => {
  if (options.cache.enabled) {
    return {
      type: "handler",
      name: "handler-ssr-with-cache",

      canHandle({
        args
      }) {
        const [event] = args;
        return event.httpMethod === "GET" && !_mimeTypes.default.lookup(event.path);
      },

      async handle({
        args,
        context
      }) {
        const [event] = args;

        const path = event.path + _querystringify.default.stringify(event.multiValueQueryStringParameters, true);

        const {
          SsrCache
        } = context.models;
        let ssrCache = await SsrCache.findByPath(path);

        if (!ssrCache) {
          ssrCache = new SsrCache();
          ssrCache.path = path;
          await ssrCache.save();
        }

        const version = event.headers["X-Cdn-Deployment-Id"];

        if (ssrCache.isEmpty) {
          await ssrCache.refresh(version);
        } else {
          if (ssrCache.isStale(version)) {
            // On expiration, asynchronously trigger SSR cache refreshing.
            // This will only increment expiresOn for the "options.cache.staleTtl" seconds, which
            // is a short duration, enough for the actual refresh to complete, which will again update the
            // expiration. Default value of "options.cache.staleTtl" is 20 seconds.
            await ssrCache.incrementExpiresOn().save();
            const Lambda = new _lambda.default({
              region: process.env.AWS_REGION
            });
            await Lambda.invoke({
              FunctionName: process.env.AWS_LAMBDA_FUNCTION_NAME,
              InvocationType: "Event",
              Payload: JSON.stringify(_objectSpread({}, event, {
                httpMethod: "POST",
                body: {
                  ssr: ["invalidateSsrCacheByPath", {
                    path: ssrCache.path,
                    refresh: true
                  }]
                }
              }))
            }).promise();
          }
        }

        let buffer = Buffer.from(ssrCache.content);
        buffer = _zlib.default.gzipSync(buffer);
        return (0, _httpHandler.createResponse)({
          type: "text/html",
          body: buffer.toString("base64"),
          isBase64Encoded: true,
          headers: {
            "Cache-Control": "public, max-age=" + ssrCache.expiresIn / 1000,
            "Content-Encoding": "gzip"
          }
        });
      }

    };
  }

  return {
    type: "handler",
    name: "handler-ssr-no-cache",

    canHandle({
      args
    }) {
      const [event] = args;
      return event.httpMethod === "GET" && !_mimeTypes.default.lookup(event.path);
    },

    async handle({
      args
    }) {
      const [event] = args;

      const path = event.path + _querystringify.default.stringify(event.multiValueQueryStringParameters, true);

      const body = await (0, _functions.getSsrHtml)(options.ssrFunction, {
        path
      });
      let buffer = Buffer.from(body);
      buffer = _zlib.default.gzipSync(buffer);
      return (0, _httpHandler.createResponse)({
        type: "text/html",
        body: buffer.toString("base64"),
        isBase64Encoded: true,
        headers: {
          "Cache-Control": "no-store",
          "Content-Encoding": "gzip"
        }
      });
    }

  };
};

exports.default = _default;
//# sourceMappingURL=ssrServe.js.map